#include <fstream>
#include <iostream>
#include <string>
#include <math.h>

using namespace std;

float lagrange(float wartxy[][2], float x, int ilosc) {
    float licznik, mianownik;
    float y = 0.0;

    for (int i = 0; i < ilosc; i++) {
        licznik = 1;
        mianownik = 1;
        for (int j = 0; j < ilosc; j++)
            if (i != j) {
               licznik *= (x - wartxy[j][0]);
               mianownik *= (wartxy[i][0] - wartxy[j][0]);
            }
        y += licznik * wartxy[i][1] / mianownik;
    }
    return y;
};

int main(int argc, char *argv[]) {
    float wezly[][2] = {0};

    fstream plik,plik2;

    plik.open("wezly.txt");
    /*
    if( plik.good() == true )
        
        cout << "Plik ok!" << endl;

    else
        cout << "Plik nie-ok!" << endl;
    */
    float temp; //zmienna tymczasowa do przerzucania danych ze strumienia do tablicy
    int i = 0, j = 0;
    while (!plik.eof()) {
        plik >> temp;
        wezly[i][j] = temp;
        j++;
        if (j % 2 == 0) {
            i++;
            j = 0;
        }
    }
    plik.close();
    
    int iloscwezlow = i;
    
    double ppodzialu[52];
    i = 0;
    
    plik2.open("ppodzialu.txt");
    /*
    if( plik2.good() == true )
        cout << "Plik2 ok!" << endl;

    else
        cout << "Plik2 nie-ok!" << endl;
       */ 
    while (!plik2.eof()) {
        plik2 >> ppodzialu[i];
        
        i++;
    }
    plik2.close();
        
    double fx;
    for(i=0;i<52;i++)
    {
        fx=2*exp(-ppodzialu[i]*ppodzialu[i]/489)-1;
        cout << ppodzialu[i] << " " << lagrange(wezly, ppodzialu[i], iloscwezlow) << " " << fx << " " << endl;
    }
    
    return 0;
}
